
#!/usr/bin/evn python2
import sys, os,
from subprocess import *

try:
	filename = os.environ[ 'C3_CONF' ]
except KeyError:
	filename = '/etc/c3.conf'
try:
	def_path = os.environ[ 'C3_PATH' ]
except KeyError:
	print "$C3_PATH should be defined with the location of the c3 binaries"

sys.path.append( def_path )
import c3_file_obj, re

try:
	file = c3_file_obj.cluster_def(filename)
except IOError:
	print "Error opening file: ", filename
	print "FAIL"
	sys.exit()

try:
	while(1):
		file.get_next_cluster()
		headnode = file.get_external_head_node()
		nodes = []
		try:
			while(1):
				node = file.get_next_node()
				if not node.dead:
					nodes.append(node.name)
		except c3_file_obj.end_of_cluster:
			pass
except c3_file_obj.no_more_clusters:
	pass
except c3_file_obj.parse_error, error:
	print error.description
	print "Somewhere around ", error.last
	print "FAIL"
	sys.exit()

#This writes the c3.conf.test file with the detected computer names
conffile = open('c3.conf.test', 'w')
conffile.write("cluster testcluster1 {\n")
conffile.write(headnode + "\n")
conffile.write(nodes[0] + "\n}\n")
conffile.write("cluster testcluster2 {\n")
conffile.write(headnode + "\n")
conffile.write(nodes[1] + "\n}")
conffile.close()

string_to_execute = "$C3_PATH/cpush -f c3.conf.test --head testcluster1: testcluster2: ./files/test /tmp"
os.system( string_to_execute )

string_to_execute = "$C3_PATH/cget -f c3.conf.test --head testcluster1: testcluster2: /tmp/test /tmp"
os.system( string_to_execute )

string_to_execute = "ls /tmp | grep test" 
p = Popen(string_to_execute, shell=True, 
          stdout=PIPE, stderr=STDOUT, close_fds=True)
line = p.communicate()[0]

if re.compile(r"test_testcluster1_" + headnode + "\s*test_testcluster2_" + headnode, re.VERBOSE).search(line):
	print "PASS"
else:
	print "FAIL"
	
string_to_execute = "$C3_PATH/crm -f c3.conf.test --head testcluster1: testcluster2: /tmp/test"
os.system( string_to_execute )
	
os.system( "rm c3.conf.test" )
os.system( "rm /tmp/test_testcluster*")
		
